#pragma once
//////////////////////////////////////////////////////////////////////
// SimpleGeo.h (Hierachical Geometry) 
// -Kyoung Shin Park (2016 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionColor.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{
	class SimpleGeo
	{
	public:
		SimpleGeo();
		~SimpleGeo();
		void init();
		void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
		bool update(float dt);

		void setTheta(float theta_) { theta = theta_; };
		void setPhi(float phi_) { phi = phi_; };
		void setPsi(float psi_) { psi = psi_; };

		void activate() { active = true;  }
		void deactivate() { active = false; }
		bool isActive() {return active;
		}

	protected:
		Program* p;
		GeometryPositionColor* geo[4];
		glm::mat4 transform[5];
		void setTransformation();

		float theta;// body angle
		float phi;// lower arm angle
		float psi;// upper arm angle
		float direction; // positive/negative direction

		bool active;
	};

}

